
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Lua学习笔记(六)：函数-续 / 憋错料</title>

    <meta name="description" content="Lua学习笔记(六)：函数-续 Lua中的函数是带有词法定界(lexical scoping)的第一类值(first-class values).第一类值指:在Lua中函数和其他值(数值.字符串)一样,函数可以被存放在变量中,也可以存放在表中,可以作为函数的参数,还可以作为函数的返回值.词法定界指:嵌套的函数可以访问他外部函数中的变量.这一特性给Lua提供了强大的编程能力. Lua中关于函数稍微难以理解的是函数也可以没有名字,匿名的.当我们提到函数名(比如print),实际上是说一个指向函数的变量,像持有其他类型的变量一样:">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Lua学习笔记(六)：函数-续</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>　　Lua中的函数是带有词法定界(lexical scoping)的第一类值(first-class values)。第一类值指：在Lua中函数和其他值(数值、字符串)一样，函数可以被存放在变量中，也可以存放在表中，可以作为函数的参数，还可以作为函数的返回值。词法定界指：嵌套的函数可以访问他外部函数中的变量。这一特性给Lua提供了强大的编程能力。</p>
<p>　　Lua中关于函数稍微难以理解的是函数也可以没有名字，匿名的。当我们提到函数名(比如print)，实际上是说一个指向函数的变量，像持有其他类型的变量一样：</p>
<pre>1 a = {p = print}
2 a.p("Hello World")    --&gt; Hello World
3 print = math.sin    -- `print‘ now refers to the sine function
4 a.p(print(1))        --&gt; 0.841470
5 sin = a.p            -- `sin‘ now refers to the print function
6 sin(10, 20)        --&gt; 10   20</pre>
<p>　　既然函数是值，那么表达式也可以创建函数了，Lua中我们经常这样写：</p>
<pre>1 function foo (x) return 2*x end   --这实际上是Lua语法的特例，原本的函数：
2 foo = function (x) return 2*x end</pre>
<p>　　函数定义实际上是一个赋值语句，将类型为function的变量赋给一个变量。我们使用function(x)..end来定义一个函数和使用{}创建一个表一样。</p>
<p>　　table标准库提供一个排序函数，接受一个表作为输入参数并排序表中的元素。这个函数必须能够对不同类型的值(字符串或者数值)按升序或者降序进行排序。Lua不是尽可能多地提供参数来满足这些情况的需要，而是接受一个排序函数作为参数(类似c++的函数对象)，排序函数接受两个排序元素作为输入参数，并且返回两者的大小关系，例如：</p>
<pre>network = {
    {name = "grauna",        IP = "210.26.30.34"},
    {name = "arraial",    IP = "210.26.30.23"},
    {name = "lua",        IP = "210.26.23.12"},
    {name = "derain",        IP = "210.26.23.20"},
}

--如果我们想通过表的name域排序
table.sort(network, function (a,b)
    return (a.name &gt; b.name)
end)</pre>
<p>　　以其他函数作为函数的函数在Lua中被称作高级函数(higher-order function)，如上面的sort。在Lua中，高级函数与普通函数没有区别，他们只是把"作为参数的函数"当作第一类值(first-class value)处理而已。</p>
<p>　　下面给出一个绘图函数的例子：</p>
<pre> 1 function eraseTerminal()
 2     io.write("\27[2J")
 3 end
 4
 5 -- writes an ‘*‘ at column ‘x‘ , ‘row y‘
 6 function mark (x,y)
 7     io.write(string.format("\27[%d;%dH*", y, x))
 8 end
 9
10 -- Terminal size
11 TermSize = {w = 80, h = 24}
12
13 -- plot a function
14 -- (assume that domain and image are in the range [-1,1])
15 function plot (f)
16     eraseTerminal()
17     for i=1,TermSize.w do
18         local x = (i/TermSize.w)*2 - 1
19         local y = (f(x) + 1)/2 * TermSize.h
20         mark(i, y)
21     end
22     io.read()  -- wait before spoiling the screen
23 end
24
25 --要想让这个例子正确运行，你必须调整你的终端类型和代码中的控制符一致
26 plot(function (x) return math.sin(x*2*math.pi) end)     --将在屏幕上输出一个正玄曲线</pre>
<p>　　1、闭包</p>
<p>　　当一个函数内部嵌套另一个函数定义时，内部的函数体可以访问外部的函数的局部变量，这种特征我们称作词法定界。虽然这看起来很清楚，事实并非如此，词法定界加上第一类函数在编程语言里是一个功能强大的概念，很少语言提供这种支持。</p>
<pre> 1 function newCounter()
 2     local i = 0
 3     return    function()     -- anonymous function
 4         i = i + 1
 5         return i
 6     end
 7 end
 8
 9 c1 = newCounter()
10 print(c1())  --&gt; 1
11 print(c1())  --&gt; 2</pre>
<p>　　匿名函数使用upvalue i保存他的计数，当我们调用匿名函数的时候i已经超出了作用范围，因为创建i的函数newCounter已经返回了，然而Lua用闭包的思想正确处理了这种情况。简单的说，闭包是一个函数以及他的的upvalues。如果我们再次调用newCounter，将创建一个新的局部变量i，因此我们得到了一个作用在新的变量i上的新闭包。</p>
<pre>1 c2 = newCounter()
2 print(c2())  --&gt; 1
3 print(c1())  --&gt; 3
4 print(c2())  --&gt; 2</pre>
<p>　　c1、c2是建立在同一函数上，但作用在同一个局部变量的不同实例上的两个不同的闭包。</p>
<p>　　技术上来讲，闭包指值而不是指函数，函数仅仅是闭包的一个原型声明；尽管如此，在不会导致混淆的情况下我们继续使用术语函数代替闭包。</p>
<p>　　闭包在完全不同的上下文中也很有用途的。因为函数被存储在普通的变量内我们可以很方便的重定义或者预定义函数。通常当你需要原始函数有一个新的实现时可以重定义函数。例如你可以重定义sin使其接受一个度数而不是弧度作为参数：</p>
<pre> 1 oldSin = math.sin
 2 math.sin = function (x)
 3     return oldSin(x*math.pi/180)
 4 end
 5
 6 --更清楚的方式
 7 do
 8     local oldSin = math.sin
 9     local k = math.pi/180
10     math.sin = function (x)
11         return oldSin(x*k)
12     end
13 end</pre>
<p>　　这样我们把原始版本放在一个局部变量内，访问sin的唯一方式是通过新版本的函数。</p>
<p>　　利用同样的特征我们可以创建一个安全的环境(也称作沙箱，和java里的沙箱一样)，当我们运行一段不信任的代码(比如我们运行网络服务器上获取的代码)时安全的环境是需要的，比如我们可以使用闭包重定义io库的open函数来限制程序打开的文件。</p>
<pre> 1 do
 2     local oldOpen = io.open
 3     io.open = function (filename, mode)
 4         if access_OK(filename, mode) then
 5             return oldOpen(filename, mode)
 6         else
 7             return nil, "access denied"
 8         end
 9     end
10 end</pre>
<p>　　2、非全局函数</p>
<p>　　Lua中函数可以作为全局变量也可以作为局部变量，我们已经看到一些例子：函数作为table的域(大部分Lua标准库使用这种机制来实现的比如io.read、math.sin)。这种情况下，必须注意函数和表语法：</p>
<pre>--1、表和函数放在一起
Lib = {}
Lib.foo = function (x,y) return x + y end
Lib.goo = function (x,y) return x - y end

--2、使用表构造函数
Lib = {
    foo = function (x,y) return x + y end,
    goo = function (x,y) return x - y end
}

--3、Lua提供另一种语法方式
Lib = {}
function Lib.foo (x,y)
    return x + y
end
function Lib.goo (x,y)
    return x - y
end</pre>
<p>　　当我们将函数保存在一个局部变量内时，我们得到一个局部函数，也就是说局部函数像局部变量一样在一定范围内有效。这种定义在包中非常有用的：因为Lua把chunk当作函数处理，在chunk内可以声明局部函数(仅仅在chunk内可见)，词法定界保证了包内的其他函数可以调用此函数。下面是声明局部函数的两种方式：</p>
<pre>--1、方式一
local f = function (...)
    ...
end

local g = function (...)
    ...
    f()   -- external local `f‘ is visible here
    ...
end

--2、方式二
local function f (...)
    ...
end</pre>
<p>　　有一点需要注意的是在声明递归局部函数的方式：</p>
<pre>1 local fact = function (n)
2     if n == 0 then
3         return 1
4     else
5         return n*fact(n-1)    -- buggy
6     end
7 end</pre>
<p>　　上面这种方式导致Lua编译时遇到fact(n-1)并不知道他是局部函数fact，Lua会去查找是否有这样的全局函数fact。为了解决这个问题我们必须在定义函数以前先声明：</p>
<pre>1 local fact
2
3 fact = function (n)
4     if n == 0 then
5         return 1
6     else
7         return n*fact(n-1)
8     end
9 end</pre>
<p>　　这样在fact内部fact(n-1)调用是一个局部函数调用，运行时fact就可以获取正确的值了。</p>
<p>　　但是Lua扩展了他的语法使得可以在直接递归函数定义时使用两种方式都可以。</p>
<p>　　在定义非直接递归局部函数时要先声明然后定义才可以：</p>
<pre>1 local f, g            -- `forward‘ declarations
2
3 function g ()
4     ...  f() ...
5 end
6
7 function f ()
8     ...  g() ...
9 end</pre>
<p>　　3、正确的尾调用(Proper Tail Calls)</p>
<p>　　Lua中函数的另一个有趣的特征是可以正确的处理尾调用(proper tail recursion， 一些书使用术语"尾递归"，虽然并未涉及到递归的概念)。</p>
<p>　　尾调用是一种类似在函数结尾的goto调用，当函数最后一个动作是调用另外一个函数时，我们称这种调用为尾调用。如：</p>
<pre>1 function f(x)
2     return g(x)
3 end
4
5 --g的调用是尾调用</pre>
<p>　　例子中f调用g后不会在做任何事情，这种情况下当被调用函数g结束时程序不需要返回到调用者f；所以尾调用之后程序不需要在栈中保留关于调用者的任何信息。一些编译器比如Lua解释器利用这种特性在处理尾调用时不使用额外的栈，我们称这种语言支持正确的尾调用。</p>
<p>　　由于尾调用不需要使用栈空间，那么尾调用递归的层次可以无限制的。例如下面调用不论n为何值不会导致栈溢出。</p>
<pre> 1 function foo (n)
 2     if n &gt; 0 then return foo(n - 1) end
 3 end
 4
 5 --需要注意的是：必须明确什么是尾调用，比如下面就不属于尾调用：
 6 function f (x)
 7     g(x)
 8     return
 9 end
10 --下面也不是尾调用
11 return g(x) + 1        -- must do the addition
12 return x or g(x)        -- must adjust to 1 result
13 return (g(x))            -- must adjust to 1 result
14
15 --Lua中类似return g(...)这种格式的调用是尾调用。
16 --但是g和g的参数都可以是复杂表达式，因为Lua会在调用之前计算表达式的值。如下面的调用也是尾调用：
17 return x[i].foo(x[j] + a*b, i + j)</pre>
<p>　　可以将尾调用理解成一种goto，在状态机的编程领域尾调用时非常有用的。状态机的应用要求函数记住每一个状态，改变状态只需要goto一个特定的函数。</p>
<p><P>Lua学习笔记(六)：函数-续</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-28 23:37:46 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/color/" title="color">color</a>, <a href="https://www.biecuoliao.com/tag/style/" title="style">style</a>, <a href="https://www.biecuoliao.com/tag/%e4%bd%bf%e7%94%a8/" title="使用">使用</a>, <a href="https://www.biecuoliao.com/tag/java/" title="java">java</a>, <a href="https://www.biecuoliao.com/tag/blog/" title="blog">blog</a>, <a href="https://www.biecuoliao.com/tag/%e6%96%87%e4%bb%b6/" title="文件">文件</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Lua学习笔记(六)：函数-续的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mm9j8YM.html" rel="bookmark">lua学习笔记之函数</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Lua学习笔记之函数 1.  函数的作用 函数主要完成指定的任务,这样的情况下函数作为调用语句使用,函数可以计算并返回值,这样的情况下函数作为赋值语句的表达式使用. 语法: funcationfunc_name(arguments-list) Statements-list end 调用函数的时候,如果参数列表为空,必须使用()表示是函数调用. Print(8*9,9/8) a = math.sin(3) +math.cos(10) print(os.date()) 上述规则有一个例外,当函数只			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0klP9P3.html" rel="bookmark">Lua学习笔记3&period; 函数可变参数和运算符、转义字符串、数组</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. Lua函数可以接受变长数目的参数,和C语言类似,在函数的参数列表中使用(...)表示函数可以接受变长参数 lua函数将参数存放在一个table中,例如arg,那么#arg可以获得参数的个数 function func_no_p(...) local arg={...} for k,v in pairs(arg} do print(v ..&quot;,&quot;) end print(&quot;输入参数个数:&quot;.. #arg) end func_no_p(1,2,34,1,&quot;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0k9eZd4.html" rel="bookmark">【Swift】学习笔记&lpar;六&rpar;&mdash;&mdash;函数</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				函数  懂编程语言的来说这个是最主要的了,不论什么语言都有函数这个概念.函数就是完毕特定任务的独立代码块. 函数怎么创建: 1.创建一个无參无返回值的函数(实际上全部的函数都有返回值,这个函数返回void,它是一个空元组) func testFunc(){ } 2.创建一个带返回值的函数 func testFunc() -&gt; String{ return &quot;hello&quot; } 3.创建一个带參数和返回值的函数 func testFunc(name: String) -&gt; St			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0ejYJb3.html" rel="bookmark">Lua学习笔记&lpar;五&rpar;：函数</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				函数有两种用途: 1).完成指定的任务,这种情况下函数作为调用语句使用: 2).计算并返回值,这种情况下函数作为赋值语句表达式使用. 1 function func_name (arguments-list) 2 statements-list; 3 end; 4 5 --调用函数的时候,如果参数列表为空,必须使用()表明是函数调用 6 print(8*9, 9/8) 7 a = math.sin(3) + math.cos(10) 8 print(os.date()) 9 10 --上述规则有			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3vKbka4.html" rel="bookmark">Lua学习笔记&lpar;七&rpar;：迭代器与泛型for</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.迭代器与闭包 迭代器是一种支持指针类型的结构,它可以遍历集合的每一个元素.在Lua中我们常常使用函数来描述迭代器,每次调用该函数就返回集合的下一个元素. 迭代器需要保留上一次成功调用的状态和下一次成功调用的状态,也就是他知道来自于哪里和将要前往哪里.闭包提供的机制可以很容易实现这个任务.记住:闭包是一个内部函数,它可以访问一个或者多个外部函数的外部局部变量.每次闭包的成功调用后这些外部局部变量都保存他们的值(状态).当然如果要创建一个闭包必须要创建其外部局部变量.所以一个典型的闭包的结构包含			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0leywB3.html" rel="bookmark">swift学习笔记&lpar;六&rpar;析构过程和使用闭包对属性进行默认值赋值</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.通过闭包和函数实现属性的默认值 当某个存储属性的默认值需要定制时,可以通过闭包或全局函数来为其提供定制的默认值. 注:全局函数结构体和枚举使用关键字static标注    函数则使用class关键字标注 当对一个属性使用闭包函数进行赋值时,每当此属性所述的类型被创建实例时,对应的闭包或函数会被调用,而他们的返回值会被作为属性的默认值. ESC: Class SomeCLass{ let someProperty:SomeType={ //给someProperty赋一个默认值 //返回一个与			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/02yb2BM.html" rel="bookmark">java之jvm学习笔记六-十二&lpar;实践写自己的安全管理器&rpar;&lpar;jar包的代码认证和签名&rpar; &lpar;实践对jar包的代码签名&rpar; &lpar;策略文件&rpar;&lpar;策略和保护域&rpar;  &lpar;访问控制器&rpar; &lpar;访问控制器的栈校验机制&rpar; &lpar;jvm基本结构&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				java之jvm学习笔记六(实践写自己的安全管理器) 安全管理器SecurityManager里设计的内容实在是非常的庞大,它的核心方法就是checkPerssiom这个方法里又调用 AccessController的checkPerssiom方法,访问控制器AccessController的栈检查机制又遍历整个 PerssiomCollection来判断具体拥有什么权限一旦发现栈中一个权限不允许的时候抛出异常否则简单的返回,这个过程实际上比我的描述要复杂 得多,这里我只是简单的一句带过,因为这			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MVq2pz4.html" rel="bookmark">lua学习笔记之基本语法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Lua学习笔记之基本语法 1.  赋值语句 赋值是改变一个变量的值和改变表域的最基本的方法. a = &quot;hello&quot;..&quot;world&quot; t.n = t.n+1 lua可以对多个变量同时赋值,变量列表和值列表的各个元素用逗号分开,赋值语句右边的值会一次赋给左边的变量. a,b = 10,2*x    &lt;--&gt;a = 10;b = 2*x 遇到赋值语句lua会先计算右边所有的值然后再执行赋值操纵,所以我们可以这样进行交换变量的值: x,y = y,x    			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MyBKZj0.html" rel="bookmark">Lua学习笔记&lpar;2&rpar; &mdash;&mdash; 风格</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前一篇大概学习了lua常用的语法,都是些刚入门时应该了解的.见这里 Lua学习笔记(1) ——语法 这篇主要记录一些关于lua代码风格的经验,如果不了解它们,还是拿着函数式或传统面向对象的风格去写lua,就永远无法了解lua的精华之所在,弃之所长,取其所短. 1. 函数类型的变量 2. 匿名函数 3. 闭包 4. 表 5. 协程 6. 虚拟机			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/L3rXlXM.html" rel="bookmark" class="title">thinkPHP的RBAC权限管理</a>
					<div>
						thinkphp自带一个权限类:RBAC.class.php,里面有生成表的create table语句,也就是它的数据库设计,还有一些方法,比如getAccessList(),可以根据管理员ID号获 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3Om1ePM.html" rel="bookmark" class="title">一个实现图片放大缩小的笨办法</a>
					<div>
						1 #import &quot;UITestAppAppDelegate.h&quot; 2 3 @implementation UITestAppAppDelegate 4 5 @synthesiz ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bnabm0.html" rel="bookmark" class="title">&lbrack;codevs2181&rsqb;田忌赛马</a>
					<div>
						试题描述 中国古代的历史故事&quot;田忌赛马&quot;是为大家所熟知的.话说齐王和田忌又要赛马了,他们各派出N匹马,每场比赛,输的一方将要给赢的一方200两黄金,如果是平局的话,双方都不必拿出钱 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02m8DAM.html" rel="bookmark" class="title">Linux禁止ping以及开启ping的方法</a>
					<div>
						Linux默认是允许Ping响应的,系统是否允许Ping由2个因素决定的:A.内核参数,B.防火墙,需要2个因素同时允许才能允许Ping,2个因素有任意一个禁Ping就无法Ping. 具体的配置方法如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3O7V7P3.html" rel="bookmark" class="title">JS 报表制作</a>
					<div>
						1: Jmgraph 工具 http://graph.jm47.com/ 2: fusionchart工具 http://www.fusioncharts.com/ 3: ichartjs 工具 ht ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kGDYd0.html" rel="bookmark" class="title">关于Tomcat自动加载更新class的小技巧</a>
					<div>
						在Tomcat的server.xml或者Tomcat.xxx\conf\Catalina\localhost\project.xml文件中里Context标签内:&lt;!-- reloadable为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KqA2K4.html" rel="bookmark" class="title">node开发</a>
					<div>
						node 开发流程1,express nodeName ; npm install;2,加入Database;var mongoose = require('mongoose'); npm insta ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4ARqQZM.html" rel="bookmark" class="title">撰淄壮作走啄撰淄壮作走啄hpvvug撰淄壮作走啄</a>
					<div>
						http://www.orion34g.com/html/3/3677/14758191.html http://www.orion34g.com/html/3/3677/14758204.html  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rkBgw4.html" rel="bookmark" class="title">OFBiz之SVN下载地址</a>
					<div>
						trunk: $ svn co http://svn.apache.org/repos/asf/ofbiz/trunk ofbiz release13.07: $ svn co http://svn. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RD6l74.html" rel="bookmark" class="title">网络介绍</a>
					<div>
						LINUX 网络配置 一些配置文件: /etc/services:服务名称和端口配置文件 /etc/hosts  :最早主机名对应ip的配置文件 /etc/resolv.conf: 本机DNS解析ip ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0j1nbDM.html" rel="bookmark" class="title">paas架构之docker&mdash;&mdash;安装</a>
					<div>
						1. 概要 本文描述docker的安装 参考官方文档:https://docs.docker.com/engine/installation/linux/ubuntulinux/ 安装操作系统: Ub ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rzAYv3.html" rel="bookmark" class="title">iOS网络加载图片缓存策略之ASIDownloadCache缓存优化</a>
					<div>
						在我们实际工程中,很多情况需要从网络上加载图片,然后将图片在imageview中显示出来,但每次都要从网络上请求,会严重影响用户体验,为了不是每次显示都需要从网上下载数据,希望将图片放到本地缓存,因此 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kozEP0.html" rel="bookmark" class="title">JAVA作业02</a>
					<div>
						一,      课堂练习 (一)构造方法 1,源代码 public class Test{ public static void main(String[] args){ Foo obj1=new F ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLvEZE3.html" rel="bookmark" class="title">精灵图技术</a>
					<div>
						在加载图片时,每加载一次,就向网络中发送一次请求icon为小图标,同样需要向网络发送请求为了节省网络资源,将页面中需要用到的icon集成到一张图中,使用时,只需发送一次请求即可在css文件中使用时,只 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVvQnpM.html" rel="bookmark" class="title">C&num; 弹出窗口查看图片</a>
					<div>
						private void ShowSelectedPicture(string path) { FileStream fs = File.OpenRead(path); //OpenRead int  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmNQLX0.html" rel="bookmark" class="title">maridb安装审计audit插件</a>
					<div>
						1.下载插件 https://mariadb.com/kb/en/mariadb-audit- plugin/ 比较新的mariadb版本audit插件直接内嵌在版本里,可以直接安装 INSTALL  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6pY9v3.html" rel="bookmark" class="title">DBscan算法C&plus;&plus;实现</a>
					<div>
						#include&lt;bits/stdc++.h&gt; #define dimense 10 //10维数据 #define N 5005 #define MAX 0xffffff #define ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0ea79g0.html" rel="bookmark" class="title">Delphi 设置时间格式</a>
					<div>
						// 设置WINDOWS系统的短日期的格式SetLocaleInfo(LOCALE_SYSTEM_DEFAULT, LOCALE_SSHORTDATE, 'yyyy-MM-dd'); Applicat ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MENy2y0.html" rel="bookmark" class="title">定时器-每秒记录日志</a>
					<div>
						1 #include&lt;iostream&gt; 2 #include&lt;windows.h&gt; 3 #include &lt;MMSystem.h&gt; 4 #pragma comme ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0ja6NoM.html" rel="bookmark" class="title">多文件链接编译</a>
					<div>
						下面有两个文件 m.c和a.c m.c extern void a(char *); int main(int ac,char **av){ static char string[] = &quot; ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 11 q. 0.026 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
